> ## Documentation Index
> Fetch the complete documentation index at: https://docs.nerves-hub.org/llms.txt
> Use this file to discover all available pages before exploring further.

# List all Firmwares for a Product



## OpenAPI

````yaml https://manage.nervescloud.com/api/openapi get /api/orgs/{org_name}/products/{product_name}/firmwares
openapi: 3.0.0
info:
  description: >
    The NervesCloud API gives users full access to their

    Orgs, Products, and corresponding Device fleets.


    The API can be used to integrate with your own systems, providing full
    access to your Product and Device data.


    The API is documented using the OpenAPI 3.0 specification.
  title: NervesCloud API
  version: 2.0.0
servers:
  - url: https://manage.nervescloud.com
    variables: {}
security:
  - bearer_auth: []
tags:
  - description: User authentication and API token creation
    name: Auth
  - description: Organization Certificate Authority management
    name: CA Certificates
  - description: >-
      Device management, including action requests eg. upgrade, reboot,
      reconnect
    name: Devices
  - description: Log lines Devices have sent over the logging extension
    name: Device Logs
  - description: >-
      Device management, including action requests eg. upgrade, reboot,
      reconnect
    name: Devices (short URL)
  - description: Device Certificate management
    name: Device Certificates
  - description: Identities a Device holds on networks NervesHub does not run
    name: Network Identities
  - description: Deployment Group and release management
    name: Deployment Groups
  - description: Firmware uploading and management
    name: Firmwares
  - description: Organization iroh endpoint id registration
    name: Iroh Endpoints
  - description: Organization management
    name: Organizations
  - description: Organization User membership management
    name: Organization Members
  - description: Product management
    name: Products
  - description: Organization Signing Key management
    name: Signing Keys
  - description: Product Support Script management
    name: Support Scripts
  - description: Platform healthcheck
    name: Platform Status
paths:
  /api/orgs/{org_name}/products/{product_name}/firmwares:
    get:
      tags:
        - Firmwares
      summary: List all Firmwares for a Product
      operationId: NervesHubWeb.API.FirmwareController.index
      parameters:
        - description: Organization Name
          example: example_org
          in: path
          name: org_name
          required: true
          schema:
            type: string
        - description: Product Name
          example: example_product
          in: path
          name: product_name
          required: true
          schema:
            type: string
      responses:
        '200':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/FirmwareListResponse'
          description: Firmware list response
        '401':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
          description: Unauthorized
        '403':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
          description: Forbidden
      callbacks: {}
      security:
        - bearer_auth: []
components:
  schemas:
    FirmwareListResponse:
      description: Response schema for multiple Firmwares
      example:
        data:
          - architecture: arm
            author: NervesHub
            platform: rpi0
            product: MyProduct
            uuid: d9f8c63a-1234-5678-abcd-ef0123456789
            version: 1.0.0
      properties:
        data:
          description: The Firmware details
          items:
            $ref: '#/components/schemas/Firmware'
          type: array
      title: FirmwareListResponse
      type: object
    ErrorResponse:
      description: Error response
      example:
        errors:
          detail: Resource Not Found or Authorization Insufficient
      properties:
        errors:
          properties:
            detail:
              type: string
          type: object
      title: ErrorResponse
      type: object
    Firmware:
      example:
        architecture: arm
        author: NervesHub
        platform: rpi0
        product: MyProduct
        tool: fwup
        uuid: d9f8c63a-1234-5678-abcd-ef0123456789
        version: 1.0.0
      properties:
        architecture:
          type: string
        author:
          type: string
        platform:
          type: string
        product:
          description: Product name
          type: string
        tool:
          description: >-
            The update tool that handles this firmware, determined from the
            uploaded file
          enum:
            - fwup
            - esp-idf
          type: string
        uuid:
          format: uuid
          type: string
        version:
          type: string
      title: Firmware
      type: object
  securitySchemes:
    bearer_auth:
      scheme: bearer
      type: http

````